clearvars;
clf
Map = ChargerCarte('CarteRoutiere.png');
load Trajectory1.mat
SGps = 50;
GPS = GenererGPS(Map,Traj,SGps);
GPS = GPS';  % a corriger
nParticules = 1000;

clf;
AfficherCarte(Map);

% On initialise les particules proche du premier GPS.
for iSample = 1:nParticules
    X(:,iSample) = SampleCarteValide(Map,GPS(1,1),GPS(2,1),SGps);
end
hold on;
plot(X(1,:),X(2,:),'g.');
w = ones(1,nParticules)./nParticules;
Traj = Traj';

for iter = 2:size(Traj,2)
        % Filtre a particule et integration
        DeltaTraj = Traj(:,iter) - Traj(:,iter-1) + 2*randn(2,1);
        for iParticule = 1:nParticules
            X(:,iParticule) = X(:,iParticule) + DeltaTraj + randn(2,1)*3;
            % On doit combiner l'evidence GPS et l'evidence de la carte
            wnew(iParticule) = gauss(norm(X(:,iParticule)-GPS(:,iter)),SGps);
            
            % Si on n'est pas sur une route, reduire le poids de la
            % particule par 90%. C'est un heurisitique en quelque sorte.
            if (~SurRoute(Map,X(1,iParticule),X(2,iParticule)))
                wnew(iParticule) = 0.10*wnew(iParticule);
            end
            
        end
        w = w.*wnew;
        
        [X w] = ParticuleResampling(X,w,0.50);
        
        Estimate(1) = sum(X(1,:).*w);
        Estimate(2) = sum(X(2,:).*w);
        
        clf
        AfficherCarte(Map);
        hold on;
        h(2) = plot(X(1,:),X(2,:),'g.'); 
        h(1) = plot(Traj(1,iter),Traj(2,iter),'bo','MarkerSize',10,'MarkerFaceColor','b');
        h(3) = plot(Estimate(1),Estimate(2),'r+','MarkerSize',13);
        h(4) = plot(GPS(1,iter),GPS(2,iter),'rs','MarkerSize',5);
        legend(h,{'Position relle' 'Particule' 'Moyenne pondre' 'Lecture GPS'},'Location', 'SouthEast','FontSize',16);
        drawnow();
end

